<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo T3<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>Trabajo realizado por Alejandro García Cestero, Álvaro Sanz Blanco, David Pacheco Valero, Ignacio Heredia Beneitez y Jorge de la Mata Marchante</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>En este apartado se debe indicar la URL del proyecto:
				<a href="https://gitlab.com/dte2020/t3/tg03">https://gitlab.com/dte2020/t3/tg03</a>".</p>
			<p>En ese proyecto debera haber un Sprint (Milestone) finalizado con el nombre "TG3".</p>
			<h3>1.3 Burndown chart</h3>
			<p>En este apartado se debe incrustar la imagen del diagrama Burndown final del Sprint TG3.</p>
			<img src="estadistica.jpg">
			<h3>1.4 Presentacion del trabajo</h3>
			<p>En este apartado se debe incluir el enlace al archivo de la presentacion con diapositivas, ubicado en el
				repositorio del proyecto.</p>
			<a href="presentacion3.pptx">Presentacion con diapositivas del trabajo TG3</a></p>
		</section>
		<section id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>
			<p>El objetivo del proyecto es comparar la implementación de dos prototipos (SVG y CANVAS) en los que se utilicen las dos tecnologías de los trabajos anteriores, una en cada prototipo.
				
				En primer lugar compararemos los dos prototipos en los que descurbriremos que las diferencias son significantes y son notablemente diferentes. Empezaremos por la diferencia en los pixeles, los graficos, las animaciones y videojuegos.

				Compararemos dos juegos conocidos como son el SNAKE y PONG, tanto con SVG como con CANVAS.

				Mostraremos por último las dos tecnologias con graficos extraidos del mismo juego.
			<h3>2.1. Requisitos funcionales</h3>
			</p>
			</p>RF: REQUISITO FUNCIONAL
			</p>
			<table>
				<tr>
					<th>Req.</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>RF01</td>
					<td>La aplicación permite mostrar el grafico en ambas tecnologías.</td>
				</tr>
				<tr>
					<td>RF02</td>
					<td>La aplicación permite mostrar el videojuego en ambas tecnologías.</td>
				</tr>
				<tr>
					<td>RF03</td>
					<td>La aplicación permite mostrar las animaciones en ambas tecnologías.</td>
				</tr>
				<tr>
					<td>RF04</td>
					<td>Debe dejar guardar el graficon en los distintos formatos de imagen.</td>
				</tr>
				<tr>
					<td>RF05</td>
					<td>Debe dejar editar en cualquiera de los navegadores.</td>

			</tr>
			<tr>				

			</table>
            <h3>2.2. Requisitos no funcionales</h3>
            
			<p>USA: Usabilidad<p>

		    <p>MAN: Mantenibilidad<p>
			
			<p>LAN: Lenguajes de alto nivel<p>
			
			<table>
				<tr>
					<th>Req.</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>USA01</td>
					<td>La aplicación tiene que dejar navegar através de sus paginas</td>
				</tr>
				<tr>
					<td>USA02</td>
					<td>Debe poder utilizarlo cualquier persona.</td>
				</tr>
				<tr>
					<td>USA03</td>
					<td>Debe tener una usabilidad bastante simple para que sea sencillo.</td>
				</tr>
				<tr>
					<td>MAN01</td>
					<td>Debe haber un cuidado en las fases tanto de diseño como en codificación y las siguientes pruebas que se puedan hacer.</td>
				</tr>
				<tr>
					<td>MAN02</td>
					<td>Debe tener una configuaración bastante sencilla para que deje editarlo de una manera sencilla.</td>
				</tr>
				<tr>
					<td>MAN03</td>
					<td>Estructura de codigo bastante sencilla.</td>
				</tr>
				<tr>
					<td>MAN04</td>
					<td>Documentación disponible para los programadores que quieran utilizar dichas tecnologías.</td>
				</tr>
				<tr>
					<td>LAN01</td>
					<td>Empleo de lenguajes estandarizados.</td>
				</tr>
				<tr>
					<td>LAN02</td>
					<td>Empleo de JavaScript.</td>
				</tr>
				<tr>
					<td>LAN03</td>
					<td>Empleo de HTML.</td>
				</tr>
			</table>

		</section>
		<section id="3">
			<h3>3.1 Criterio 1: Líneas de código</h3>
			<ul>
				<li>Nombre del criterio: Líneas de código.</li>
				<li>Descripcion: Número de líneas de código utilizadas para que se pueda ejecutar.</li>
				<li>Tipo de valor: Numérico.</li>
			</ul>
			<h3>3.2 Criterio 2: Programa utilizado</h3>
				<ul>
					<li>Nombre del criterio: Programa utilizado</li>
					<li>Descripcion: Especifica el programa o editores que se han usado para la creación.</li>
					<li>Tipo de valor: texto</li>
				</ul>
			<h3>3.3 Criterio 3: Dificultad</h3>
				<ul>
					<li>Nombre del criterio: Dificultad</li>
					<li>Descripcion: Define en una palabra el grado de dificultad/entendimiento del programa.</li>
					<li>Tipo de valor: Baja | Media-Baja | Media | Media-Alta | Alta </li>
				</ul>
			<h3>3.4 Criterio 4: Compatibilidad de Navegador</h3>
				<ul>
					<li>Nombre del criterio:Compatibilidad de navegador</li>
					<li>Descripcion: Asigna la compatibilidad de ejecución con ciertos navegadores que pondremos posteriormente.</li>
					<li>Tipo de valor: Bool (SI/NO)</li>
				</ul>
			<h4>3.4.1 Criterio 4.1: </h4>
				<ul>
					<li>Nombre del criterio: Compatibilidad de Google Chrome</li>
					<li>Descripcion: Asigna la compatibilidad del programa con Google Chrome</li>
					<li>Tipo de valor: bool (SI/NO)</li>
				</ul>
			<h4>3.4.2 Criterio 4.2: </h4>
				<ul>
					<li>Nombre del criterio: Compatibilidad de Firefox</li>
					<li>Descripcion: Asigna la compatibilidad del programa con Firefox</li>
					<li>Tipo de valor: bool (SI/NO)</li>
				</ul>
			<h4>3.4.3 Criterio 4.3: </h4>
				<ul>
					<li>Nombre del criterio: Compatibilidad de Microsoft Edge</li>
					<li>Descripcion: Asigna la compatibilidad del programa con Microsoft Edge</li>
					<li>Tipo de valor: bool (SI/NO)</li>
				</ul>
			<h4>3.4.4 Criterio 4.4: </h4>
				<ul>
					<li>Nombre del criterio: Compatibilidad de Internet Explorer</li>
					<li>Descripcion: Asigna la compatibilidad del programa con Internet Explorer</li>
					<li>Tipo de valor: bool (SI/NO)</li>
				</ul>
			<h3>3.5 Criterio 5: Calidad del gráfico</h3>
				<ul>
					<li>Nombre del criterio: ...</li>
					<li>Descripcion: ...</li>
					<li>Tipo de valor: ...</li>
					<li>Nombre del criterio:Calidad del gráfico</li>
					<li>Descripcion: Asigna mediante un valor numérico la calidad gráfica de los programas al ejecutarse.</li>
					<li>Tipo de valor: Numérico entre (1-10)</li>
				</ul>
				....
			<h3>3.6 Criterio 6: Tiempo de carga</h3>
				<ul>
					<li>Nombre del criterio: Tiempo de carga</li>
					<li>Descripcion: Asigna un valor número al tiempo que tarda en lanzar la ejecución el programa (tiempo de inicio).</li>
					<li>Tipo de valor: Numérico (segundos)</li>
				</ul>
			<h3>3.7 Criterio 7: Velocidad/Fluidez</h3>
				<ul>
					<li>Nombre del criterio: Velocidad/Fluidez</li>
					<li>Descripcion: Especifica como de fluido se ve el gráfico representado.</li>
					<li>Tipo de valor: Numérico entre (1-10)</li>
				</ul>
			<h3>3.8 Criterio 8: Tiempo empleado en desarrollo</h3>
				<ul>
					<li>Nombre del criterio: Tiempo empleado en desarrollo</li>
					<li>Descripcion: Especifica el tiempo empleado en desarrollar el programa.</li>
					<li>Tipo de valor: Numérico (horas)</li>
				</ul>
			<h3>3.9 Criterio 9: Recursos necesarios</h3>
				<ul>
					<li>Nombre del criterio: Recursos necesarios</li>
					<li>Descripcion: Lista los recursos necesarios para poder ejecutar el programa.</li>
					<li>Tipo de valor: Texto libre</li>
				</ul>
			<h3>3.10 Criterio 10: Interacción con el usuario.</h3>
				<ul>
					<li>Nombre del criterio: Interacción con el usuario</li>
					<li>Descripcion: Especifica si el programa realiza una interacción con el usuario o si este necesita del usuario para llevar a cabo su función.</li>
					<li>Tipo de valor: Bool (SI/NO)</li>
				</ul>
			<h3>3.11 Criterio 11: Contiene IA.</h3>
				<ul>
					<li>Nombre del criterio: Contiene IA</li>
					<li>Descripcion: Especifica si el programa contiene algún tipo de bot que interaccione con el usuario.</li>
					<li>Tipo de valor: Bool (SI/NO)</li>
				</ul>
			<h3>3.12 Criterio 12: Almacenamiento.</h3>
				<ul>
					<li>Nombre del criterio: Almacenamiento</li>
					<li>Descripcion: Declara el tamaño usado para almacenar todos los archivos que comprenden el programa.</li>
					<li>Tipo de valor:Numérico (KB)</li>
				</ul>
		</section>

		<section id="4">
			<h2>4. Implementación del prototipo con tecnología A</h2>
			<p>Hay que indicar la URL de la carpeta en el repositorio de GitLab que contiene todos los documentos,
				código, etc., creados durante
				la implementación del prototipo. Comprobar que en la URL aparece "master" que es donde debe estar la
				versión final.</p>
			<p>(Por ejemplo, si el grupo fuera el m5, se indicaría) Toda la documentación del prototipo A se
				encuentra en:
				<a
					href="https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-A">https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-A</a>.
			</p>
			<h3>4.1 Implementación prototipo (SNAKE) para CANVAS</h3>
			<p>Enlace al prototipo:
				<a
					href="https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-A/Snake-JavaScript-CANVAS">https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-A/Snake-JavaScript-CANVAS</a>.
			</p>
			<p> - 1 Archivo comprimido en el que se encuentra todo el contenido, este archivo no es necesario descomprimirlo, solo nos servirá para transporte.</p>
			<p> - 1 Archivo "Index.html", que contiene el esquema de visualización y la llamada al código de ejecución.</p>
			<p> - 1 Archivo "README", que contiene intrucciones básicas sobre como ejecutar.</p>
			<p> - 2 Carpetas: Una llamada "img" que contiene las imágenes usadas en ell .js y otras "audio" que contiene los audios usados en el .js.</p>
			<p> Por último contiene 1 archivo "snake.js", en el que se encuentra todo el código de ejecución del programa, asi como las variable sy objetos creados.</p>

			<p> Para ejecutarlo debemos de hacer doble clic en el archivo "index.html" y nos abrirá el programa (juego del snake), en nuestro navegador predeterminado:</p>
			<img src="SNAKE_CANVAS.PNG">

			<h3>4.2 Implementación prototipo (PONG) para CANVAS</h3>
			<p>Enlace al prototipo:
				<a
					href="https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-A/pong-master-CANVAS">https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-A/pong-master-CANVAS</a>.
			</p>
			<p> - 2 archivos tipo audio "blip.mp3" y "blip.ogg", que son los audios la "paleta" del usuario y de la máquina.</p>
			<p> - 1 archivo README en el que se encuentran intrucciones básicas sobre el programa.</p>
			<p> - 1 archivo "guardfile" que es donde se van guardando durante la partida los puntos marcados.</p>
			<p> - 1 archivo "game.html" que contiene el esquema de visualización y la llamada a los .js para la ejecución del juego.</p>
			<p> - 5 archivos .js:</p>
			<p> 	- "game.js" --> Que contiene la inicialización del espacio.</p>
			<p> 	- "entity.js" --> Que inicializa los objetos: marcador y campo.</p>
			<p> 	- "ball.js" --> Inicializa la "bola" con la que se va a realizar el juego</p>
			<p> 	- "padles.js" --> Inicializa las paletas del jugador (usuario) y de la máquina (IA).</p>
			<p> 	- "pong.js" --> Que pone todo en reinicio menos el marcador para ir guardando los puntos anotados.</p>
			<img src="PONG_CANVAS.PNG">

		</section>

		<section id="5">
			<h2>5. Implementación del prototipo con tecnología SVG</h2>
			<p>Hay que indicar la URL de la carpeta en el repositorio de GitLab que contiene todos los documentos,
				código, etc., creados durante
				la implementación del prototipo. Comprobar que en la URL aparece "master" que es donde debe estar la
				versión final.</p>
			<p>(Por ejemplo, si el grupo fuera el m5, se indicaría) Toda la documentación del prototipo SVG se
				encuentra en:
				<a
					href="https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-B">https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-B/</a>.
			</p>
			<p>A continuación hay que describir lo que hay en esa carpeta, para que cualquier persona interesada lo
				entienda y pueda modificar, instalar y usar el prototipo.</p>

			<p>El formato de este apartado es libre y pueden crearse subapartados si se considera necesario.</p>
		</section>
		
			<h3>5.1. Documentación del diseño</h3>
			<p>Vamosa a comentar como hemos creado el diseño de los dos videojuegos que presentaremos a continuación, hemos diseñado el juego de pong y de snake en base a SVG, se puede utilizar en cualquier navegador pero es preferible que sea Chrome, Safari o Mozilla. 
			La interfaz de usuario es bastante sencilla como mostraremos a continuación</p> 
			<h4>5.1.1Diseño del videojuego pong</h4>
			<img src="interfaz-pong.png">
			<h4>5.1.2Diseño del videojuego snake</h4>
			<img src="interfaz-snake.png">
			<h3>5.2. Documentación del código</h3>
			El codigo es sencillo se trata primero de hacer un javascript y por ultimo hacer un index.html y ejecutarlo. Mostraremos a continuación el codigo.
			<h4>5.2.1.Codigo del videojuego pong</h4>
			<img src ="pong-codigo.png">
			<h4>5.2.2.Codigo del videojuego snake</h4>
			<img src ="snake-codigo.png">
			<h3>5.3. Documentación de instalación</h3>
			<p>1. Entraremos a la carpeta del prototipo B <a href="https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-B/">https://gitlab.com/dte2020/t3/tg03/-/tree/master/prototipo-B/</a>
			</p>2. Descargaremos la capeta completa</p>
			</p>3. Descomprimimos la carpeta</p>
			</p>4. Dentro de la misma tendremos los dos juegos</p>
			</p>5. Si queremos abrir el pong abrimos la carpeta de "pong-svg" y unicamente tendremos que ejecutar doble click en la carpeta llamada "index.html" y que se ejecute en nuestro navegador</p>
			</p>6. Si queremos abrir el pong abrimos la carpeta de "snake-svg" y unicamente tendremos que ejecutar doble click en la carpeta llamada "index.html" y que se ejecute en nuestro navegador</p>	
			</p>7. Por último quedaria jugar y disfrutar del mismo, y del que queramos</p>

		<section id="6">
			<h2>6. Comparacion de los prototipos</h2>
			<p>Debe incluir al menos una tabla resumen cruzando los criterios y los
				valores de cada tecnología. Con una columna de comentarios sobre la comparación.</p>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Canvas</th>
					<th>SVG</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Lineas de codigo</td>
					<td>370</td>
					<td>450</td>
					<td>Líneas de codigo de los archivos HTML y los JS</td>
				</tr>
				<tr>
					<td>Programa utilizado</td>
					<td>Notepadd++</td>
					<td>Notepadd++</td>
					<td>Cualquier editor de texto nos valdría</td>
				</tr>
				<tr>
					<td>Dificultad</td>
					<td>Media-Baja</td>
					<td>Media-Baja</td>
					<td>Unica dificultad el necesitar conceptos basicos de JavaScript</td>
				</tr>
				<tr>
					<td>Compatiblidad de navegador</td>
					<td>Total</td>
					<td>total</td>
					<td>Ambas tecnologias tienen total compatibilidad con los principales navegadores (Firefox, Google Chrome, Microsoft Edge e internet Explorer </td>
				</tr>
				<tr>
					<td>Calidad del grafico</td>
					<td>5</td>
					<td>10</td>
					<td>En SVG no se pixelan las imágenes al hacer zoom (principal ventaja de SVG)</td>
				</tr>

				<tr>
					<td>Tiempo de carga</td>
					<td>10</td>
					<td>7</td>
					<td>Canvas carga mucho mas rapido, por eso es elegido para desarrollar juegos en navegadores, sin embargo, nuestros ejemplos no son lo sufientemente pesados para notar la diferencia</td>
				</tr>

				<tr>
					<td>Velocidad / Fluidez</td>
					<td>10</td>
					<td>8</td>
					<td>Igual que el criterio anterior</td>
				</tr>

				<tr>
					<td>Tiempo empleado en el desarrollo</td>
					<td>15</td>
					<td>18</td>
					<td>Tiempo estimado, medido en horas</td>
				</tr>
				<tr>
					<td>Recursos necesarios</td>
					<td>Editor de texto y navegador web</td>
					<td>Editor de texto y navegador web</td>
					<td>Cualquier editor valdría, y un navegador que sea compatible con la tecnologia</td>
				</tr>
				<tr>
					<td>Interaccion con el usuario</td>
					<td>Si</td>
					<td>Si</td>
					<td>Ambos ejemplos interactan, un ejemplo de esta interaccion es el marcador</td>
				</tr>
				<tr>
					<td>Contiene IA</td>
					<td>Si</td>
					<td>No</td>
					<td>En canvas, el rival mueve su cursos para devolver la pelota, a diferencia de SVG, donde se queda quieto</td>
				</tr>
				<tr>
					<td>Almacenamiento</td>
					<td>29KB</td>
					<td>33KB</td>
					<td>Diferencia minima debido a la simpleza del ejemplo</td>
				</tr>

			</table>
		</section>

		<section id="7">
			<h2>7. Conclusiones</h2>
			<p>Una vez realizadas las implementaciones en ambas tecnologías, podemos concluir que ambas son totalmente funcionales.
		Sin embargo, en nuestros ejemplos, observamos mejor resultado en la implemetancion realizada con SVG, ya que esta posee mucha mejor calidad de grafico, y dado que se trata de un ejemplo simple, y sin demasiada carga,
	el tiempo de respuesta, el cual es la principal ventaja de Canvas, no se ve reflejado.
Tambien comentar que, al tratarse de juegos tan popolares como pong o snake, hemos encontrado ejemplos suficientes para realizar la implementacion, lo cual era una principal desventaja de SVG.
Ambas implementaciones hacen uso intensivo de JavaScript, siendo este de un nivel básico de programacion. 
En teoría, canvas tiene muchas mas posibilidades y es mucho mas popular, sin embargo, en nuestros ejemplos, obtenemos mejor resultado en SVG por lo ya explicado.
</p>
		</section>

		<p></p>

	</main>

</body>

</html>
